part of './functions.dart';

/// Definition os callback that's return a key for the [toMap] function
typedef GeneratorKey<GV, GK> = GK Function(GV value);

/// Returns a Map with keys that's generated by generator.
Map<K, V> toMap<K, V>(Iterable<V> list, GeneratorKey<V, K> generatorKey) {
  return Map<K, V>.fromIterables(list.map(generatorKey), list);
}
